An instance is a micro vm running an application.
List Instances
Get one or many instances with their current status and configuration.
query Parameters
uuidThe UUID of the resource.
nameThe name of the resource.
detailscountfromorderThe sort order used by list endpoints.
sortbyThe sort field used by list endpoints.
tagsList Instances › Request Body optional
uuidThe UUID of the resource.
nameThe name of the resource.
Decision Table
| Variant | Matching Criteria |
|---|---|
| type = object · requires: uuid | |
| type = object · requires: name |
uuidThe UUID of the resource.
nameThe name of the resource.
List Instances › Responses
The request has succeeded.
statusThe status of the response.
op_time_usThe operation time in microseconds.
messageAn optional message providing additional information about the status.
The response data for this request.
A list of errors which may have occurred during the request.
Create Instance
Create an instance in Unikraft Cloud.
Create Instance › Request Body
nameThe name of the resource. If not provided, a random name is generated. The name must be unique within the context of your account.
nodeThe name of the node to place the resource on. If not provided, the platform picks one. Only accepted on metros that span multiple nodes.
The image to use for the instance.
Either an image or a template must be specified. Accepts either a plain
image reference string ("nginx:latest") or an object carrying additional
pull configuration ({"url": "nginx:latest", "pull_policy": "always"}).
argsThe arguments to pass to the instance when it starts.
Environment variables to set for the instance.
memory_mbMemory in MB to allocate for the instance. Default is 128.
min_memory_mbLower bound in MB for memory vertical scaling. Setting this or
max_memory_mb enables memory vertical scaling, which is only supported
by microVM instances. The instance boots with this amount of memory, and
memory_mb selects the initial allocation within the bounds, defaulting
to min_memory_mb. Must be lower than max_memory_mb, and within the
user's memory limits. Cannot be used with templates that have a
snapshot, branch_from or checkpoint.
max_memory_mbUpper bound in MB for memory vertical scaling. Setting this or
min_memory_mb enables memory vertical scaling. Defaults to the user's
maximum memory limit. Must be higher than min_memory_mb by at least
the platform's memory block size. Cannot be used with templates that
have a snapshot, branch_from or checkpoint.
The service group configuration when creating an instance.
When creating an instance, either a previously created (persistent) service group can be referenced (either through its name or UUID), or a new (ephemeral) service group can be created for the instance by specifying the list of services it should expose and optionally the domains it should use. Not used by template instances.
Volumes to attach to the instance.
This list can contain both existing and new volumes to create as part of the instance creation. Existing volumes can be referenced by their name or UUID. New volumes can be created by specifying a name, size in MiB, and mount point in the instance. The mount point is the directory in the instance where the volume will be mounted.
autostartWhether the instance should start automatically on creation.
Must be set to true when timeout_s is specified.
replicasNumber of additional replicas to create. The total number of instances
created is replicas + 1. Defaults to 0.
restart_policyRestart policy for the instance. This defines how the instance
should behave when it stops or crashes. Cannot be combined with
the delete-on-stop feature.
Scale-to-zero configuration for the instance. Requires
service_group to be set. Cannot be combined with the
delete-on-stop feature.
vcpusNumber of vCPUs to allocate for the instance. Defaults to 1.
min_vcpusLower bound for vCPU vertical scaling. Setting this or max_vcpus
enables vCPU vertical scaling, which is only supported by microVM
instances. The instance boots with this number of vCPUs, and vcpus
selects the initial allocation within the bounds, defaulting to
min_vcpus. Must be lower than max_vcpus, and within the user's vCPU
limits. Cannot be used with templates that have a snapshot,
branch_from or checkpoint.
max_vcpusUpper bound for vCPU vertical scaling. Setting this or min_vcpus
enables vCPU vertical scaling. Defaults to the user's maximum vCPU
limit. Must be higher than min_vcpus. Cannot be used with templates
that have a snapshot, branch_from or checkpoint.
featuresFeatures to enable for the instance. Features are specific
configurations or capabilities that can be enabled for the
instance. The scale-to-zero and delete-on-stop features are
mutually exclusive.
timeout_sTimeout in seconds to wait for all new instances to reach running
state. Requires autostart to be set. If you autostart your
new instance, you can wait for it to finish starting with a
blocking API call if you specify a wait timeout greater than
zero. No wait performed for a value of 0.
Read-Only Memory (ROM) blobs to attach to the instance. Unikraft Cloud supports the ability to attach Read-Only Memory (ROM) blobs to instances. It allows you to create a general-purpose base image and then customize individual instances by attaching code or data as separate ROM blobs.
Plugins to attach to the instance. Plugins let you attach small helper
programs to an instance and reach each one over a direct, authenticated
HTTP endpoint. Each plugin loads from its own ROM image, mounts at
/uk/plugins/<plugin_name>, and is reachable at
.../v1/instances/<uuid>/plugins/<plugin_name>/<path>. At most 8 plugins
may be attached to an instance.
tagsTags to associate with the instance.
Annotations to associate with the instance.
Unlike tags, annotations also reach the guest: they are included in the instance's startdata, and selected keys can be injected into the console log output.
Keys follow the Kubernetes annotation key syntax, [<prefix>/]<name>:
the optional prefix is a non-wildcard DNS subdomain of at most 253
characters, and the name is at most 63 characters of [-_.a-zA-Z0-9]
starting and ending with an alphanumeric. Values are unconstrained apart
from ASCII control characters. An instance holds at most 256 annotations.
When the instance inherits annotations from a template, branch, or checkpoint, the given annotations are merged into them rather than replacing them. On a key clash the value given here wins.
Template instances. An existing instance can be saved as a template. This template is then used to create new instances that inherit the exact configuration and state the original instance had when the template was created.
sched_priorityThe scheduling priority for the instance. Only settable by users with scheduling priority override permissions.
Schedules for the instance. Scheduled operations let you automatically
start, stop, delete, or exec a command in the instance on a calendar-
based schedule. For exec schedules, set the args field to the command
and its arguments. Each instance stores its own schedules, and cloning
preserves them.
Automatic delete-on-idle/request-limit configuration. Not used for template instances.
hostnameThe hostname of the instance.
If not provided, the hostname will be set to the instance name. The hostname must be a valid DNS label (e.g., "my-instance") and is used for internal DNS resolution within the Unikraft Cloud network.
Dependencies of the instance.
A list of instance identifiers (name or UUID) that this instance depends on. Dependencies define startup ordering and can be used to ensure that prerequisite instances are running before this instance starts.
Reference to an existing instance to branch from. The instance can be
running or stopped. If the source instance is running, a snapshot will be
taken asynchronously and the new instance will wait for it to complete
before starting. Mutually exclusive with image and template.
Reference to an existing checkpoint to create the instance from. The
checkpoint must be in the checkpoint state. The new instance will be
created with the same configuration and state as the checkpoint. Mutually
exclusive with image, template, and branch_from.
gatewayThe default gateway to configure inside the guest.
nameserverThe DNS resolver to configure inside the guest.
Network interfaces to attach to the instance.
typeThe type of virtual machine to use for the instance. Defaults to micro,
which runs on Firecracker. full runs on QEMU instead and is required
for GPU passthrough (see gpus) and, in the future, Windows VMs. QEMU-
backed instances currently do not support scale-to-zero, templates,
branching, or checkpointing, and only support block-based volumes (no
virtiofs). Requires a plan with full VM support and cannot be combined
with template, branch_from, or checkpoint.
gpusNumber of GPUs to attach to the instance. Currently restricted to at most
- Requires
typeto befulland a plan with GPU support. A GPU stays assigned to the instance, even while stopped, until the instance is deleted. Cannot be combined withtemplate,branch_from, orcheckpoint.
wait_timeout_msDeprecated: Use timeout_s instead. Timeout in milliseconds to
wait for all new instances to reach running state. Requires
autostart to be set. If timeout_s is not set, this value is
converted by rounding up to the next full second. No wait
performed for a value of 0.
Create Instance › Responses
The request has succeeded.
statusThe status of the response.
op_time_usThe operation time in microseconds.
messageAn optional message providing additional information about the status.
The response data for this request.
A list of errors which may have occurred during the request.
Update Instances
Update instances by ID(s).
Update Instances › Request Body
propThe property to modify.
opThe operation to perform on the property.
uuidThe UUID of the resource.
nameThe name of the resource.
idA client-provided identifier for tracking this operation in the response.
valueThe value for the update operation. The type depends on the property and operation:
- For "image": image reference string, or object with image url, credentials, headers and pull policy
- For "args": string or array of strings
- For "env": object (for SET/ADD) or string/array of strings (for DEL)
- For "memory_mb": integer
- For "vcpus": integer
- For "scale_to_zero": object with cooldown_time_ms, policy, and stateful fields
- For "tags": array of strings
- For "delete_lock": boolean
- For "schedules": array of schedule objects (with name, when, action, and optional args fields) for SET/ADD, or array of schedule names for DEL. Use action "exec" together with args to execute a command at the scheduled time.
- For "autokill": object with time_ms and num_requests fields
- For "hostname": string (valid DNS label)
- For "roms": array of ROM objects (with name and image fields) for SET/ADD, or array of ROM names for DEL
- For "plugins": array of plugin objects (with name, image, and optional config and
authorization fields) for SET/ADD. The deprecated
romfield is accepted in place ofimage. - For "dependencies": array of instance identifiers (name or UUID)
- For "sched_priority": SchedPriority enum value ("normal", "medium", "high", "admin")
- For "annotations": object (for SET/ADD) or string/array of strings (for DEL)
Update Instances › Responses
The request has succeeded.
statusThe status of the response.
op_time_usThe operation time in microseconds.
messageAn optional message providing additional information about the status.
The response data for this request.
A list of errors which may have occurred during the request.
Delete Instances
Delete instances by ID(s).
Delete Instances › Request Body
uuidThe UUID of the resource.
nameThe name of the resource.
timeout_sTimeout in seconds to wait for the instance to be deleted. No wait performed for a value of 0.
dont_retainDelete immediately without retention. If the instance is already being retained, this will force its deletion. Ignored if retention for instances is not configured.
Delete Instances › Responses
The request has succeeded.
statusThe status of the response.
op_time_usThe operation time in microseconds.
messageAn optional message providing additional information about the status.
The response data for this request.
A list of errors which may have occurred during the request.
List Checkpoint Instances
Get one or more checkpoint instances by their UUID(s) or name(s).
query Parameters
uuidThe UUID of the resource.
nameThe name of the resource.
detailscountfromorderThe sort order used by list endpoints.
sortbyThe sort field used by list endpoints.
tagsList Checkpoint Instances › Request Body
uuidThe UUID of the resource.
nameThe name of the resource.
Decision Table
| Variant | Matching Criteria |
|---|---|
| type = object · requires: uuid | |
| type = object · requires: name |
uuidThe UUID of the resource.
nameThe name of the resource.
List Checkpoint Instances › Responses
The request has succeeded.
statusThe status of the response.
op_time_usThe operation time in microseconds.
messageAn optional message providing additional information about the status.
The response data for this request.
A list of errors which may have occurred during the request.
Create Checkpoint Instances
Create a checkpoint from an existing instance. A checkpoint captures the state of an instance at a specific point in time. Checkpoints can be created from running, stopped, or standby instances.
Create Checkpoint Instances › Request Body
The source instance to create a checkpoint from (by name or UUID).
nameThe name of the checkpoint. If not provided, a name will be generated.
nodeThe name of the node to place the checkpoint on. Must be the node of the source instance. Only accepted on metros that span multiple nodes.
timeout_sTimeout in seconds to wait for the checkpoint to be created. No wait performed for a value of 0.
tagsTags to associate with the checkpoint.
Automatic delete-on-idle configuration for the new checkpoint.
Create Checkpoint Instances › Responses
The request has succeeded.
statusThe status of the response.
op_time_usThe operation time in microseconds.
messageAn optional message providing additional information about the status.
The response data for this request.
A list of errors which may have occurred during the request.
Update Checkpoint Instances
Update (modify) one or more checkpoint instances by ID(s) (name or UUID).
Update Checkpoint Instances › Request Body
propThe property to modify.
opThe operation to perform on the property.
uuidThe UUID of the resource.
nameThe name of the resource.
idA client-provided identifier for tracking this operation in the response.
valueThe value for the update operation. The type depends on the property and operation:
- For "tags": array of strings
- For "delete_lock": boolean
- For "autokill": object with time_ms field
Update Checkpoint Instances › Responses
The request has succeeded.
statusThe status of the response.
op_time_usThe operation time in microseconds.
messageAn optional message providing additional information about the status.
The response data for this request.
A list of errors which may have occurred during the request.
Delete Checkpoint Instances
Delete the specified checkpoint instance(s) by ID(s) (name or UUID). After this call the IDs of the checkpoint instances are no longer valid.
Delete Checkpoint Instances › Request Body
uuidThe UUID of the resource.
nameThe name of the resource.
Decision Table
| Variant | Matching Criteria |
|---|---|
| type = object · requires: uuid | |
| type = object · requires: name |
uuidThe UUID of the resource.
nameThe name of the resource.
Delete Checkpoint Instances › Responses
The request has succeeded.
statusThe status of the response.
op_time_usThe operation time in microseconds.
messageAn optional message providing additional information about the status.
The response data for this request.
A list of errors which may have occurred during the request.
Get Checkpoint History
Get the checkpoint history of one or more checkpoint instances. Returns the ordered list of checkpoints in each checkpoint's history.
query Parameters
uuidThe UUID of the resource.
nameThe name of the resource.
Get Checkpoint History › Request Body
uuidThe UUID of the resource.
nameThe name of the resource.
Decision Table
| Variant | Matching Criteria |
|---|---|
| type = object · requires: uuid | |
| type = object · requires: name |
uuidThe UUID of the resource.
nameThe name of the resource.
Get Checkpoint History › Responses
The request has succeeded.
statusThe status of the response.
op_time_usThe operation time in microseconds.
messageAn optional message providing additional information about the status.
The response data for this request.
A list of errors which may have occurred during the request.
Get Checkpoint Instance by UUID
Get a single checkpoint instance by its UUID.
path Parameters
uuidquery Parameters
detailsGet Checkpoint Instance by UUID › Responses
The request has succeeded.
statusThe status of the response.
op_time_usThe operation time in microseconds.
messageAn optional message providing additional information about the status.
The response data for this request.
A list of errors which may have occurred during the request.
Update Checkpoint Instance by UUID
Update (modify) a checkpoint instance by its UUID.
path Parameters
uuidUpdate Checkpoint Instance by UUID › Request Body
propThe property to modify.
opThe operation to perform on the property.
idA client-provided identifier for tracking this operation in the response.
valueThe value for the update operation. The type depends on the property and operation:
- For "tags": array of strings
- For "delete_lock": boolean
- For "autokill": object with time_ms field
Update Checkpoint Instance by UUID › Responses
The request has succeeded.
statusThe status of the response.
op_time_usThe operation time in microseconds.
messageAn optional message providing additional information about the status.
The response data for this request.
A list of errors which may have occurred during the request.
Delete Checkpoint Instance by UUID
Delete a specified checkpoint instance by its UUID. After this call the UUID of the checkpoint instance is no longer valid.
path Parameters
uuidDelete Checkpoint Instance by UUID › Responses
The request has succeeded.
statusThe status of the response.
op_time_usThe operation time in microseconds.
messageAn optional message providing additional information about the status.
The response data for this request.
A list of errors which may have occurred during the request.
Get Checkpoint History by UUID
Get the checkpoint history of a checkpoint instance by its UUID. Returns the ordered list of checkpoints in the checkpoint's history.
path Parameters
uuidGet Checkpoint History by UUID › Responses
The request has succeeded.
statusThe status of the response.
op_time_usThe operation time in microseconds.
messageAn optional message providing additional information about the status.
The response data for this request.
A list of errors which may have occurred during the request.
Get Instances Checkpoint History
Get the checkpoint history of one or more instances. Returns the ordered list of checkpoints associated with each instance.
query Parameters
uuidThe UUID of the resource.
nameThe name of the resource.
Get Instances Checkpoint History › Request Body
uuidThe UUID of the resource.
nameThe name of the resource.
Decision Table
| Variant | Matching Criteria |
|---|---|
| type = object · requires: uuid | |
| type = object · requires: name |
uuidThe UUID of the resource.
nameThe name of the resource.
Get Instances Checkpoint History › Responses
The request has succeeded.
statusThe status of the response.
op_time_usThe operation time in microseconds.
messageAn optional message providing additional information about the status.
The response data for this request.
A list of errors which may have occurred during the request.
Get Instances Logs
Get instances logs.
query Parameters
uuidThe UUID of the resource.
nameThe name of the resource.
offsetThe byte offset of the log output to receive. A negative sign makes the offset relative to the end of the log.
limitThe amount of bytes to return at most.
Get Instances Logs › Request Body
uuidThe UUID of the resource.
nameThe name of the resource.
offsetThe byte offset of the log output to receive. A negative sign makes the offset relative to the end of the log.
limitThe amount of bytes to return at most.
Get Instances Logs › Responses
The request has succeeded.
statusThe status of the response.
op_time_usThe operation time in microseconds.
messageAn optional message providing additional information about the status.
The response data for this request.
A list of errors which may have occurred during the request.
Get Instances Metrics
Get instances metrics.
query Parameters
uuidThe UUID of the resource.
nameThe name of the resource.
Get Instances Metrics › Request Body optional
uuidThe UUID of the resource.
nameThe name of the resource.
Decision Table
| Variant | Matching Criteria |
|---|---|
| type = object · requires: uuid | |
| type = object · requires: name |
uuidThe UUID of the resource.
nameThe name of the resource.
Get Instances Metrics › Responses
The request has succeeded.
statusThe status of the response.
op_time_usThe operation time in microseconds.
messageAn optional message providing additional information about the status.
The response data for this request.
A list of errors which may have occurred during the request.
Start Instances
Start instances by ID(s).
Start Instances › Request Body
uuidThe UUID of the resource.
nameThe name of the resource.
timeout_sTimeout in seconds to wait for the instance to reach running state. If you start your instance, you can wait for it to finish starting with a blocking API call if you specify a wait timeout greater than zero. No wait performed for a value of 0.
wait_timeout_msDeprecated: Use timeout_s instead. Timeout in milliseconds to
wait for the instance to reach running state. If timeout_s is
not set, this value is converted by rounding up to the next full
second. No wait performed for a value of 0.
Start Instances › Responses
The request has succeeded.
statusThe status of the response.
op_time_usThe operation time in microseconds.
messageAn optional message providing additional information about the status.
The response data for this request.
A list of errors which may have occurred during the request.
Stop Instances
Stop instances by ID(s).
Stop Instances › Request Body
uuidThe UUID of the resource.
nameThe name of the resource.
forceWhether to immediately force stop the instance.
drain_timeout_msTimeout for draining connections in milliseconds. No draining will occur if set to 0. The instance does not receive new connections in the draining phase. The instance is stopped when the last connection has been closed or the timeout expired. The maximum timeout may vary. Use -1 for the largest possible value. Ignored if force is set.
Note: This endpoint does not block. Use the wait endpoint for the instance to reach the stopped state.
quickWhether to perform a quick shutdown. This flag is overridden by force.
ifstateOnly stop the instance if it is in this state.
dumpIf set, forces the VMM to shutdown immediately and generate a coredump. Can only be used in conjunction with force.
Stop Instances › Responses
The request has succeeded.
statusThe status of the response.
op_time_usThe operation time in microseconds.
messageAn optional message providing additional information about the status.
The response data for this request.
A list of errors which may have occurred during the request.
Suspend Instances
Suspend instances by ID(s).
Suspend Instances › Request Body
uuidThe UUID of the resource.
nameThe name of the resource.
drain_timeout_msTimeout for draining connections in milliseconds. No draining will occur if set to 0. Use -1 for the largest possible value.
Suspend Instances › Responses
The request has succeeded.
statusThe status of the response.
op_time_usThe operation time in microseconds.
messageAn optional message providing additional information about the status.
The response data for this request.
A list of errors which may have occurred during the request.
List template instances
Get one or more template instances.
query Parameters
uuidThe UUID of the resource.
nameThe name of the resource.
detailscountfromorderThe sort order used by list endpoints.
sortbyThe sort field used by list endpoints.
tagsList template instances › Request Body optional
uuidThe UUID of the resource.
nameThe name of the resource.
Decision Table
| Variant | Matching Criteria |
|---|---|
| type = object · requires: uuid | |
| type = object · requires: name |
uuidThe UUID of the resource.
nameThe name of the resource.
List template instances › Responses
The request has succeeded.
statusThe status of the response.
op_time_usThe operation time in microseconds.
messageAn optional message providing additional information about the status.
The response data for this request.
A list of errors which may have occurred during the request.
Create template instances from Instances
Convert instances to template instances.
Create template instances from Instances › Request Body
uuidThe UUID of the resource.
nameThe name of the resource.
timeout_sTimeout in seconds to wait for the template instances to be created. A value of -1 means to wait indefinitely until the instance reaches the desired state. No wait performed for a value of 0.
Automatic delete-on-idle configuration for the new template.
Create template instances from Instances › Responses
The request has succeeded.
statusThe status of the response.
op_time_usThe operation time in microseconds.
messageAn optional message providing additional information about the status.
The response data for this request.
A list of errors which may have occurred during the request.
Update template instances
Update template instances by ID(s).
Update template instances › Request Body
propThe property to modify.
opThe operation to perform.
uuidThe UUID of the resource.
nameThe name of the resource.
idA client-provided identifier for tracking this operation in the response.
valueThe value for the update operation. The type depends on the property and operation:
- For "tags": array of strings
- For "delete_lock": boolean
- For "autokill": object with time_ms field
- For "image": image reference string or object (SET only)
- For "roms": array of ROM objects (SET only)
- For "plugins": array of plugin objects (SET only)
Update template instances › Responses
The request has succeeded.
statusThe status of the response.
op_time_usThe operation time in microseconds.
messageAn optional message providing additional information about the status.
The response data for this request.
A list of errors which may have occurred during the request.
Delete template instances
Delete template instances by ID(s).
Delete template instances › Request Body
uuidThe UUID of the resource.
nameThe name of the resource.
Decision Table
| Variant | Matching Criteria |
|---|---|
| type = object · requires: uuid | |
| type = object · requires: name |
uuidThe UUID of the resource.
nameThe name of the resource.
Delete template instances › Responses
The request has succeeded.
statusThe status of the response.
op_time_usThe operation time in microseconds.
messageAn optional message providing additional information about the status.
The response data for this request.
A list of errors which may have occurred during the request.
Get template instance by UUID
Get a single template instance by UUID.
path Parameters
uuidquery Parameters
detailsGet template instance by UUID › Responses
The request has succeeded.
statusThe status of the response.
op_time_usThe operation time in microseconds.
messageAn optional message providing additional information about the status.
The response data for this request.
A list of errors which may have occurred during the request.
Update template instance by UUID
Update a template instance by UUID.
path Parameters
uuidUpdate template instance by UUID › Request Body
propThe property to modify.
opThe operation to perform.
idA client-provided identifier for tracking this operation in the response.
valueThe value for the update operation. The type depends on the property and operation:
- For "tags": array of strings
- For "delete_lock": boolean
- For "autokill": object with time_ms field
- For "image": image reference string or object (SET only)
- For "roms": array of ROM objects (SET only)
- For "plugins": array of plugin objects (SET only)
Update template instance by UUID › Responses
The request has succeeded.
statusThe status of the response.
op_time_usThe operation time in microseconds.
messageAn optional message providing additional information about the status.
The response data for this request.
A list of errors which may have occurred during the request.
Delete template instance by UUID
Delete a template instance by UUID.
path Parameters
uuidDelete template instance by UUID › Responses
The request has succeeded.
statusThe status of the response.
op_time_usThe operation time in microseconds.
messageAn optional message providing additional information about the status.
The response data for this request.
A list of errors which may have occurred during the request.
Wait for Instances States
Wait for instances to reach states.
query Parameters
uuidThe UUID of the resource.
nameThe name of the resource.
The desired state to wait for. Default is running.
timeout_mstimeout_sWait for Instances States › Request Body
uuidThe UUID of the resource.
nameThe name of the resource.
stateThe desired state to wait for. Default is running.
timeout_sTimeout in seconds to wait for the instance to reach the desired state. If the timeout is reached, the request will fail with an error. A value of -1 means to wait indefinitely until the instance reaches the desired state. No wait performed for a value of 0.
timeout_msDeprecated: Use timeout_s instead. Timeout in milliseconds to
wait for the instance to reach the desired state. If timeout_s is
not set, this value is converted by rounding up to the next full
second. A value of -1 means to wait indefinitely.
Wait for Instances States › Responses
The request has succeeded.
statusThe status of the response.
op_time_usThe operation time in microseconds.
messageAn optional message providing additional information about the status.
The response data for this request.
A list of errors which may have occurred during the request.
Get Instance by UUID
Get a single instance by UUID.
path Parameters
uuidquery Parameters
detailsGet Instance by UUID › Responses
The request has succeeded.
statusThe status of the response.
op_time_usThe operation time in microseconds.
messageAn optional message providing additional information about the status.
The response data for this request.
A list of errors which may have occurred during the request.
Update Instance by UUID
Update instance by UUID.
path Parameters
uuidUpdate Instance by UUID › Request Body
propThe property to modify.
opThe operation to perform on the property.
idA client-provided identifier for tracking this operation in the response.
valueThe value for the update operation. The type depends on the property and operation:
- For "image": image reference string, or object with image url, credentials, headers and pull policy
- For "args": string or array of strings
- For "env": object (for SET/ADD) or string/array of strings (for DEL)
- For "memory_mb": integer
- For "vcpus": integer
- For "scale_to_zero": object with cooldown_time_ms, policy, and stateful fields
- For "tags": array of strings
- For "delete_lock": boolean
- For "schedules": array of schedule objects (with name, when, action, and optional args fields) for SET/ADD, or array of schedule names for DEL. Use action "exec" together with args to execute a command at the scheduled time.
- For "autokill": object with time_ms and num_requests fields
- For "hostname": string (valid DNS label)
- For "roms": array of ROM objects (with name and image fields) for SET/ADD, or array of ROM names for DEL
- For "plugins": array of plugin objects (with name, image, and optional config and
authorization fields) for SET/ADD. The deprecated
romfield is accepted in place ofimage. - For "dependencies": array of instance identifiers (name or UUID)
- For "sched_priority": SchedPriority enum value ("normal", "medium", "high", "admin")
- For "annotations": object (for SET/ADD) or string/array of strings (for DEL)
Update Instance by UUID › Responses
The request has succeeded.
statusThe status of the response.
op_time_usThe operation time in microseconds.
messageAn optional message providing additional information about the status.
The response data for this request.
A list of errors which may have occurred during the request.
Delete Instance by UUID
Delete instance by UUID.
path Parameters
uuidDelete Instance by UUID › Request Body optional
timeout_sTimeout in seconds to wait for the instance to be deleted. No wait performed for a value of 0.
dont_retainDelete immediately without retention. If the instance is already being retained, this will force its deletion. Ignored if retention for instances is not configured.
Delete Instance by UUID › Responses
The request has succeeded.
statusThe status of the response.
op_time_usThe operation time in microseconds.
messageAn optional message providing additional information about the status.
The response data for this request.
A list of errors which may have occurred during the request.
Get Instance Checkpoint History by UUID
Get the checkpoint history of an instance by its UUID. Returns the ordered list of checkpoints associated with the instance.
path Parameters
uuidGet Instance Checkpoint History by UUID › Responses
The request has succeeded.
statusThe status of the response.
op_time_usThe operation time in microseconds.
messageAn optional message providing additional information about the status.
The response data for this request.
A list of errors which may have occurred during the request.
Get Instance Logs by UUID
Get instance logs by UUID.
path Parameters
uuidGet Instance Logs by UUID › Request Body
offsetThe byte offset of the log output to receive. A negative sign makes the offset relative to the end of the log.
limitThe amount of bytes to return at most.
Get Instance Logs by UUID › Responses
The request has succeeded.
statusThe status of the response.
op_time_usThe operation time in microseconds.
messageAn optional message providing additional information about the status.
The response data for this request.
A list of errors which may have occurred during the request.
Get Instance Metrics by UUID
Get instance metrics by UUID.
path Parameters
uuidGet Instance Metrics by UUID › Responses
The request has succeeded.
statusThe status of the response.
op_time_usThe operation time in microseconds.
messageAn optional message providing additional information about the status.
The response data for this request.
A list of errors which may have occurred during the request.
Start Instance by UUID
Start instance by UUID.
path Parameters
uuidStart Instance by UUID › Request Body
timeout_sTimeout in seconds to wait for the instance to reach running state. If you start your instance, you can wait for it to finish starting with a blocking API call if you specify a wait timeout greater than zero. No wait performed for a value of 0.
wait_timeout_msDeprecated: Use timeout_s instead. Timeout in milliseconds to
wait for the instance to reach running state. If timeout_s is
not set, this value is converted by rounding up to the next full
second. No wait performed for a value of 0.
Start Instance by UUID › Responses
The request has succeeded.
statusThe status of the response.
op_time_usThe operation time in microseconds.
messageAn optional message providing additional information about the status.
The response data for this request.
A list of errors which may have occurred during the request.
Stop Instance by UUID
Stop instance by UUID.
path Parameters
uuidStop Instance by UUID › Request Body
forceWhether to immediately force stop the instance.
drain_timeout_msTimeout for draining connections in milliseconds. No draining will occur if set to 0. The instance does not receive new connections in the draining phase. The instance is stopped when the last connection has been closed or the timeout expired. The maximum timeout may vary. Use -1 for the largest possible value. Ignored if force is set.
Note: This endpoint does not block. Use the wait endpoint for the instance to reach the stopped state.
quickWhether to perform a quick shutdown. This flag is overridden by force.
ifstateOnly stop the instance if it is in this state.
dumpIf set, forces the VMM to shutdown immediately and generate a coredump. Can only be used in conjunction with force.
Stop Instance by UUID › Responses
The request has succeeded.
statusThe status of the response.
op_time_usThe operation time in microseconds.
messageAn optional message providing additional information about the status.
The response data for this request.
A list of errors which may have occurred during the request.
Suspend Instance by UUID
Suspend instance by UUID.
path Parameters
uuidSuspend Instance by UUID › Request Body
drain_timeout_msTimeout for draining connections in milliseconds. No draining will occur if set to 0. Use -1 for the largest possible value.
Suspend Instance by UUID › Responses
The request has succeeded.
statusThe status of the response.
op_time_usThe operation time in microseconds.
messageAn optional message providing additional information about the status.
The response data for this request.
A list of errors which may have occurred during the request.
Wait for Instance State by UUID
Wait for instance state by UUID.
path Parameters
uuidWait for Instance State by UUID › Request Body
stateThe desired state to wait for. Default is running.
timeout_sTimeout in seconds to wait for the instance to reach the desired state. If the timeout is reached, the request will fail with an error. A value of -1 means to wait indefinitely until the instance reaches the desired state. No wait performed for a value of 0.
timeout_msDeprecated: Use timeout_s instead. Timeout in milliseconds to
wait for the instance to reach the desired state. If timeout_s is
not set, this value is converted by rounding up to the next full
second. A value of -1 means to wait indefinitely.
Wait for Instance State by UUID › Responses
The request has succeeded.
statusThe status of the response.
op_time_usThe operation time in microseconds.
messageAn optional message providing additional information about the status.
The response data for this request.
A list of errors which may have occurred during the request.